#include <libgnorba/gnorba.h>
#include <libgnorba/gnome-factory.h>


PortableServer_POA poa;
PortableServer_POAManager poa_manager;
void
corba_exception (CORBA_Environment* ev)
{
  switch (ev->_major) {
  case CORBA_SYSTEM_EXCEPTION:
    g_log ("GEdit CORBA", G_LOG_LEVEL_DEBUG,
	   "CORBA system exception %s.\n",
	   CORBA_exception_id (ev));
    break;
  case CORBA_USER_EXCEPTION:
    g_log ("GEdit CORBA", G_LOG_LEVEL_DEBUG,
	   "CORBA user exception: %s.\n",
	   CORBA_exception_id (ev));
    break;
  default:
    break;
  }
}


/* From mc package */
dnd_try_to_activate_running_copy ()
{
  CORBA_Object name_service;
  CORBA_Environment ev;
  CosNaming_NameComponent nc[3] = {{"GNOME", "subcontext"},
				   {"Servers", "subcontext"},
				   {"gmc_filemanager_factory", "object"}};
  CosNaming_Name          nom = {0, 3, nc, CORBA_FALSE};
  CORBA_Object retval = CORBA_OBJECT_NIL;
	
  CORBA_exception_init (&ev);
	
  name_service = gnome_name_service_get();
  if (name_service == CORBA_OBJECT_NIL)
    goto out;

  retval = CosNaming_NamingContext_resolve (name_service, &nom, &ev);
  if (ev._major == CORBA_USER_EXCEPTION
      && strcmp(CORBA_exception_id(&ev), ex_CosNaming_NamingContext_NotFound) == 0){
    retval = CORBA_OBJECT_NIL;
    goto out;
  }

  if (CORBA_Object_is_nil (retval, &ev))
    goto out;
  /* [FIXME] */
  GNOME_FileManagerFactory_create_window (retval, home_dir, &ev);
  
  if (ev._major != CORBA_NO_EXCEPTION)
    retval = CORBA_OBJECT_NIL;
 out:
  CORBA_exception_free (&ev);
  CORBA_Object_release (name_service, &ev);
  return retval != CORBA_OBJECT_NIL;
}


void
dnd_corba_init (void)
{

  global_ev = g_new0 (CORBA_Environment, 1);
  
  CORBA_exception_init (global_ev);
  
  global_orb = gnome_CORBA_init ("DND", VERSION, &argc, argv,
				 options, 0, &ctx, global_ev);
  
  corba_exception (global_ev);
  
  root_poa = (PortableServer_POA)
    CORBA_ORB_resolve_initial_references (global_orb, "RootPOA", global_ev);
  corba_exception (global_ev);
  

  root_poa_manager = PortableServer_POA__get_the_POAManager
    (root_poa, global_ev);
  corba_exception (global_ev);
  
  if (global_ev->_major != CORBA_NO_EXCEPTION){
    printf ("Can not get the POAmanager");
    return;
  }
  
  PortableServer_POAManager_activate (root_poa_manager, global_ev);
  corba_exception (global_ev);
  
  name_service = gnome_name_service_get ();
  
}

  

  
