#ifndef DND_GRAPHIC_H
#define DND_GRAPHIC_H

#include <GL/gl.h>
#include <GL/glu.h>
#include "molecule.h"

enum {
  DND_GRAPHICS_BOND,
  DND_GRAPHICS_COIL,
  DND_GRAPHICS_SHEET,
  DND_GRAPHICS_HELIX,
  DND_GRAPHICS_CYLINDER,
  DND_GRAPHICS_SPHERE
};


typedef struct _dnd_graphics_info GraphicsInfo;
typedef struct _light_info        LightInfo;

struct _dnd_graphics_info 
{
  int     graphics_mode;
  int     render_mode;
  double   bond_line_width;
  double   coil_radius;
  double   cylinder_radius;
  
  int     segments;
  
  GList    *light_list;
};


struct _light_info
{
  gint    light_enum;
  GLfloat  light_pos[4];
  Color   light_color;
};

void dnd_init_graphics_info (GraphicsInfo *g_info);
void dnd_display (DNDData *data);
void dnd_display_pick (DNDData *data);
void dnd_display_label (Pos *pos, char *label, unsigned int fontbase);


#endif
