#include <gnome.h>
#include "dnd_main.h"
#include "dnd_session.h"

/* Session management */

int save_state (GnomeClient        *client,
                gint                phase,
                GnomeRestartStyle   save_style,
                gint                shutdown,
                GnomeInteractStyle  interact_style,
                gint                fast,
                gpointer            client_data)
{
  DNDWindow *window = (DNDWindow *) client_data;
  gchar *prefix= gnome_client_get_config_prefix (client);
  gchar *argv[]= { "rm", "-r", NULL };

  /* Save the state using gnome-config stuff. */
  gnome_config_push_prefix (prefix);

  gnome_mdi_save_state (window->mdi, "MDI Session");

  gnome_config_set_int ("MDI Session/mdi_mode",
			window->properties.mdi_mode);
  
  gnome_config_pop_prefix();
  gnome_config_sync();
  
  /* Here is the real SM code. We set the argv to the parameters needed
     to restart/discard the session that we've just saved and call
     the gnome_session_set_*_command to tell the session manager it. */
  argv[2] = gnome_config_get_real_path (prefix);
  gnome_client_set_discard_command (window->client, 3, argv);
	
  /* Set commands to clone and restart this application.  Note that we
     use the same values for both -- the session management code will
     automatically add whatever magic option is required to set the
     session id on startup.  */

  argv[0] = window->command;
  gnome_client_set_clone_command (client, 1, argv);
  gnome_client_set_restart_command (client, 1, argv);
  
  return TRUE;
}

gint
client_die (GnomeClient *client, gpointer client_data)
{
  gtk_exit (0);
  
  return FALSE;
}
