#include <gnome.h>
#include "dnd_sm.h"

/* Session management */

static void
dnd_SM_save_state (DNDWindow *window)
{
  
  /* [FIXME] : add information */
    
  gnome_config_set_bool ("Gneral/restarted", TRUE);
  
}

static gboolean
dnd_SM_retore_state (DNDWindow *window)
{
  gboolean restarted;
  
  gnome_config_push_prefix (gnome_client_get_config_prefix (window->client));
 
  /* [FIXME] : add information */

  restarted = gnome_config_get_bool ("General/restarted=0");
  
  gnome_config_pop_prefix ();
  
  return restarted;
}


static int
save_state (GnomeClient        *client,
	    gint                phase,
	    GnomeRestartStyle   save_style,
	    gint                shutdown,
	    GnomeInteractStyle  interact_style,
	    gint                fast,
	    gpointer            client_data)
{
  DNDWindow *window = (DNDWindow *) client_data;
  gchar *prefix= gnome_client_get_config_prefix (client);
  gchar *argv[]= { "rm", "-r", NULL };

  /* Save the state using gnome-config stuff. */
  gnome_config_push_prefix (prefix);

  dnd_SM_save_state (window);

  gnome_config_pop_prefix();
  gnome_config_sync();
  /* Here is the real SM code. We set the argv to the parameters needed
     to restart/discard the session that we've just saved and call
     the gnome_session_set_*_command to tell the session manager it. */
  argv[2] = gnome_config_get_real_path (prefix);
  gnome_client_set_discard_command (window->client, 3, argv);
	
  /* Set commands to clone and restart this application.  Note that we
     use the same values for both -- the session management code will
     automatically add whatever magic option is required to set the
     session id on startup.  */

  argv[0] = window->command;
  gnome_client_set_clone_command (client, 1, argv);
  gnome_client_set_restart_command (client, 1, argv);
  
  return TRUE;
}

static gint
client_die (GnomeClient *client, gpointer client_data)
{
  gtk_exit (0);
  
  return FALSE;
}

void
dnd_SM_init (DNDWindow *window)
{
  g_return_if_fail (window != NULL);
  g_return_if_fail (window->command != NULL);
  
  window->client = gnome_master_client ();
  
  gtk_signal_connect (GTK_OBJECT (window->client), "save_yourself",
		      GTK_SIGNAL_FUNC (save_state), window);
  gtk_signal_connect (GTK_OBJECT (window->client), "die",
		      GTK_SIGNAL_FUNC (client_die), NULL);
  
}

gboolean
dnd_SM_retore (DNDWindow *window)
{
  gboolean restarted;
  
  if (GNOME_CLIENT_CONNECTED (window->client))
    {
      /* [FIXME] : What do I read */
      restarted = dnd_SM_retore_state (window);
    }
  else
    {
      restarted= FALSE;
    }

  return restarted;
}

