#include <gnome.h>
#include "dnd_toolbar.h"
#include "dnd_command.h"

static GnomeUIInfo toolbar_info[] = {
  GNOMEUIINFO_ITEM_STOCK(N_("Close"), 
			 N_("Close the current document"),
			 (gpointer) file_close_cb, 
			 GNOME_STOCK_PIXMAP_CLOSE),
  GNOMEUIINFO_ITEM_STOCK(N_("Open File"),
			 N_("Open a document"),
			 (gpointer) file_open_cb,
			 GNOME_STOCK_PIXMAP_OPEN),
  GNOMEUIINFO_ITEM_STOCK(N_("Save"),
			 N_("Save the current document with the same name"),
			 (gpointer) file_save_cb,
			 GNOME_STOCK_PIXMAP_SAVE),
  GNOMEUIINFO_ITEM_STOCK(N_("Save As"),
			 N_("Save the current document with a different name"),
			 (gpointer) file_save_as_cb,
			 GNOME_STOCK_PIXMAP_SAVE_AS),
  GNOMEUIINFO_SEPARATOR,
  GNOMEUIINFO_ITEM_STOCK(N_("Exit"), 
			 N_("Exit the program"), 
			 (gpointer) file_quit_cb,
			 GNOME_STOCK_PIXMAP_QUIT),
  GNOMEUIINFO_END
};


void
create_dnd_toolbar (DNDData *data)
{
#ifdef DND_USE_MDI
  gnome_mdi_set_toolbar_template (data->window->mdi, toolbar_info);
#else
  gnome_app_create_toolbar_with_data (GNOME_APP (data->window->app),
				      toolbar_info,
				      (gpointer) data);
#endif
}

    
