#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "dnd_util.h"
#include "molecule.h"


void
pos_update (Molecule *mol)
{
  vector3 max_pos, min_pos, cen_pos;
  GList   *list;
  Pos     *pos;
  
  list = mol->pos_list;
  pos = list->data;
  
  v3_initialize (&max_pos, pos->x, pos->y, pos->z);
  v3_initialize (&min_pos, pos->x, pos->y, pos->z);
  
  for (list = list->next; list; list = list->next)
    {
      pos = list->data;
      
      if (max_pos.x < pos->x)
	max_pos.x = pos->x;
      if (max_pos.y < pos->y)
	max_pos.y = pos->y;
      if (max_pos.z < pos->z)
	max_pos.z = pos->z;
      
      if (min_pos.x > pos->x)
	min_pos.x = pos->x;
      if (min_pos.y > pos->y)
	min_pos.y = pos->y;
      if (min_pos.z > pos->z)
	min_pos.z = pos->z;
    }
  
  cen_pos.x = (min_pos.x + max_pos.x)/2.;
  cen_pos.y = (min_pos.y + max_pos.y)/2.;
  cen_pos.z = (min_pos.z + max_pos.z)/2.;
  
  for (list = mol->pos_list; list; list = list->next)
    {
      pos = list->data;
      
      v3_subtract (pos, &cen_pos);
    }
}

	  
