#include <math.h>

double
maxwell_boltzmann_distribution (double mass, double temper)
{
  double beta;
  double rho;
  double maxwell;
  
  beta = sqrt (mass / (2.0*boltzmann * temper));
  
  rho = drand48 ();
  xspeed = erf_inv (rho) / beta;
  rho = drand48 ();
  yspeed = erf_inv (rho) / beta;
  rho = drand48 ();
  zspeed = erf_inv (rho) / beta;
  
  maxwell = sqrt (xspeed * xspeed + yspeed * yspeed + zspeed * zspeed);
  
  return maxwell;
    
}

static double
erf_inv (double y)
{
  double a[4] = {0.886226899, -1.645349621, 0.914624893, -0.140543331};
  double b[4] = {-2.118377725,  1.442710462, -0.329097515,  0.012229801};
  double c[4] = {-1.970840454, -1.624906493, 3.429567803,  1.641345311};
  double d[2] = {3.543889200,  1.637067800};
  double x, z;

  if (fabs (y) >= 1.0)
    y = 2.0 * drand48() - 1.0;
  
  if (fabs (y) < 0.7)
    {
      z = y * y;
      x = y * (((a[3] * z + a[2]) * z + a[1]) * z + a[0]) /
	((( b[3] * z + b[2]) * z + b[1]) * z + 1.0);
    }
  else if (y > 0.7 && y < 1.0)
    {
      z = sqrt (-log (1.0 - y) / 2.0);
      x = (((c[3] * z + c[2]) * z + c[1]) * z * c[0]) /
	((d[1] * z + d[0]) * z + 1.0);
    }
  else if (y < -0.7 && y > -1.0)
    {
      z = sqrt (-log (1.0 + y) / 2.0);
      x = -(((c[3] * z + c[2]) * z + c[1]) * z * c[0]) /
	((d[1] * z + d[0]) * z + 1.0);
    }
  
  x += (erf (x) - y) / (2.0 /sqrt(M_PI) * exp (-x * x));
  x += (erf (x) - y) / (2.0 /sqrt(M_PI) * exp (-x * x));
  
  return x;
}
