#ifndef _MD_H
#define _MD_H

enum {
  DND_LJ_POT,
  DND_NONE_POT
};

typedef struct _md_data MDData;
typedef struct _control_data Control;
typedef struct _system_data  System;


struct _md_data
{
  GSList *command_line;
  Molecule *mol;
  Control  *control;
  /* Param    *param; */
  System   *system;
};


struct _control_data
{
  int    nsteps;  /* Number of timesteps to execute */ 
  double dt; /* time step size */
  gboolean do_rattle;
  double temper;
  
};


struct _system_data
{
  vector3 h0, h1, h2;
  GList   *cell_list;
  GList   *cell_pair_list;
  gdouble pot_ene, kin_ene;
  int     pot_type;
  int     natoms;       /* atom number */
  
  /* --- Force Field --- */
  vector3 *pos_old;
  vector3 *vel;
  vector3 *acc;
  vector3 *force;

};




void read_commands (MDData *data, char *fname);
void run_commands (MDData *data);

#endif
