#include <stdio.h>
#include <glib.h>
#include "molecule.h"
#include "dnd_util.h"
#include "md.h"

void
read_commands (MDData *data, char *fname)
{
  char buffer[120];
  FILE *infile;
  GSList *slist;
  char *buf;
  
  g_return_if_fail (fname != NULL);
  g_return_if_fail (data != NULL);
  
  infile = fopen (fname, "rt");
  
  g_return_if_fail (infile != NULL);
  
  slist = NULL;
  
  while (dnd_read_line (infile, buffer))
    {
      if (dnd_blank_string (buffer))
	continue;
      
      buf = g_strdup (buffer);
      
      if (slist == NULL)
	{
	  slist = g_slist_append (slist, buf);
	  data->command_line = slist;
	}
      else 
	{
	  slist = g_slist_append (slist, buf);
	  slist = slist->next;
	}
    }
}


