#include <glib.h>
#include <stdio.h>
#include "rtf.h"
#include "dnd_util.h"

RTF_Residue *
rtf_get_residue (char *res_name)
{
  RTF_Residue *res = g_hash_table_lookup (residue_hash, res_name);

  if (res == NULL)
    res = g_hash_table_lookup (presidue_hash, res_name);

  if (res == NULL)
    {
      g_error ("There is no residue name \"%s\" in Residue Topology File\n",
	       res_name);
      exit (1);
    }
  
  return res;
}


RTF_Atom *
rtf_get_atom (RTF_Residue *res, char *atom_name)
{
  RTF_Atom *atom;
  GList   *ls;
  gboolean ok;
  
  for (ls = res->atom_list; ls; ls = ls->next)
    {
      atom = ls->data;
      
      if (str_eq (atom->name, atom_name))
	{
	  ok = TRUE;
	  break;
	}
    }
  
  if (ok)
    return atom;
  else
    {
      g_error ("There is no Atom Name \"%s\" in Residue name \"%s\" | Residue Topology File\n",
	       atom_name, res->name);
      exit (1);
    }
  
}
